# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`windows_shortcuts`](#windows_shortcuts): Windows Shortcuts

## Classes

### <a name="windows_shortcuts"></a>`windows_shortcuts`

Manage Microsoft Windows shortcuts

],

],

],

],

#### Examples

##### 

```puppet
include windows_shortcuts
```

#### Parameters

The following parameters are available in the `windows_shortcuts` class:

* [`lnks`](#-windows_shortcuts--lnks)
* [`lnks_base`](#-windows_shortcuts--lnks_base)
* [`urls`](#-windows_shortcuts--urls)
* [`urls_base`](#-windows_shortcuts--urls_base)
* [`log_output`](#-windows_shortcuts--log_output)

##### <a name="-windows_shortcuts--lnks"></a>`lnks`

Data type: `Array[Hash]`

Array of .LNK shortcut hashes
Example: [
{
  file_name: 'Example01',
  parent_folder: 'C:\\Users\\Public\\Desktop',
  target_path: 'C:\\Windows\\write.exe',
  description: 'An example LNK shortcut',
},
{
  file_name: 'Example02',
  parent_folder: 'C:\\Users\\Public\\Desktop',
  target_path: 'C:\\Program Files (x86)\\Mozilla Firefox\\firefox.exe',
  description: 'Another example LNK shortcut',
  target_arguments: 'http://its.uiowa.edu',
},
{
  file_name: 'Example03',
  parent_folder: 'C:\\Users\\Public\\Desktop',
  set_run_as_administrator: true,
  target_path: 'C:\\Windows\\notepad.exe',
  target_arguments: 'C:\\Windows\\System32\\drivers\\etc\\hosts',
  icon_file: 'C:\\Windows\\System32\\shell32.dll',
  icon_index: 152,
  description: 'One more example LNK shortcut',
  window_style: '3',
  working_directory: 'C:\\Windows',
},
{
  file_name: 'Example04',
  parent_folder: 'C:\\Users\\Public\\Desktop',
  target_path: 'C:\\Windows',
},
{
  file_name: 'Example99.lnk',
  parent_folder: 'C:\\Users\\Public\\Desktop',
  ensure: 'absent',
},

Default value: `[]`

##### <a name="-windows_shortcuts--lnks_base"></a>`lnks_base`

Data type: `Array[Hash]`

Array of .LNK shortcut hashes that should be common across multiple nodes
   Typically set within common.yaml, with $lnks param being set in Roles and/or Nodes
Example: [
{
  file_name: 'Default01',
  parent_folder: 'C:\\Users\\Public\\Desktop',
  target_path: 'C:\\Company\\tool.exe',
  description: 'An useful tool shortcut',
},

Default value: `[]`

##### <a name="-windows_shortcuts--urls"></a>`urls`

Data type: `Array[Hash]`

Array of .URL shortcut hashes
Example: [
{
  file_name: 'Example01.url',
  parent_folder:> 'C:\\Users\\Public\\Desktop',
  url: 'https://www.puppet.com',
},
{
  file_name: 'Example02.url',
  parent_folder: 'C:\\Users\\Public\\Desktop',
  url: 'https://www.gitlab.com',
  icon_file: 'C:\\Program Files\\Git\\git-cmd.exe',
  icon_index: 0,
},
{
  file_name: 'Example99.url',
  parent_folder: 'C:\\Users\\Public\\Desktop',
  ensure: 'absent',
},

Default value: `[]`

##### <a name="-windows_shortcuts--urls_base"></a>`urls_base`

Data type: `Array[Hash]`

Array of .URL shortcut hashes that should be common across multiple nodes
   Typically set within common.yaml, with $urls param being set in Roles and/or Nodes
Example: [
{
  file_name: 'Default01.url',
  parent_folder:> 'C:\\Users\\Public\\Desktop',
  url: 'https://www.company.com',
},

Default value: `[]`

##### <a name="-windows_shortcuts--log_output"></a>`log_output`

Data type: `Boolean`

Boolean used to enable additional logging output
Example: true

Default value: `false`

